#COPYRIGHT 2014 ESRI
#
#TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
#Unpublished material - all rights reserved under the
#Copyright Laws of the United States.
#
#For additional information, contact:
#Environmental Systems Research Institute, Inc.
#Attn: Contracts Dept
#380 New York Street
#Redlands, California, USA 92373
#
#email: contracts@esri.com
from __future__ import with_statement
from .arcobjects.arcobjectconversion import convertArcObjectToPythonObject, gptoolnotsupported
from .geoprocessing._base import gptooldoc, gp, gp_fixargs
"""This is an automatically generated module with Python interfaces for geoprocessing toolboxes (Spatial Analyst Tools(sa)). Do not edit this file directly."""

@gptooldoc('ACosH_sa', None)
def ACosH(in_raster_or_constant=None):
    """ACosH_sa(in_raster_or_constant)
       
       Calculates the inverse hyperbolic cosine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ACosH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('ACos_sa', None)
def ACos(in_raster_or_constant=None):
    """ACos_sa(in_raster_or_constant)
       
       Calculates the inverse cosine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ACos_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('ASinH_sa', None)
def ASinH(in_raster_or_constant=None):
    """ASinH_sa(in_raster_or_constant)
       
       Calculates the inverse hyperbolic sine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ASinH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('ASin_sa', None)
def ASin(in_raster_or_constant=None):
    """ASin_sa(in_raster_or_constant)
       
       Calculates the inverse sine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ASin_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('ATan2_sa', None)
def ATan2(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """ATan2_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Calculates the inverse tangent (based on x,y) of cells in a raster.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ATan2_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('ATanH_sa', None)
def ATanH(in_raster_or_constant=None):
    """ATanH_sa(in_raster_or_constant)
       
       Calculates the inverse hyperbolic tangent of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ATanH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('ATan_sa', None)
def ATan(in_raster_or_constant=None):
    """ATan_sa(in_raster_or_constant)
       
       Calculates the inverse tangent of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ATan_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Abs_sa', None)
def Abs(in_raster_or_constant=None):
    """Abs_sa(in_raster_or_constant)
       
       Calculates the absolute value of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Abs_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Aggregate_sa', None)
def Aggregate(in_raster=None, cell_factor=None, aggregation_type=None, extent_handling=None, ignore_nodata=None):
    """Aggregate_sa(in_raster, cell_factor, {SUM | MAXIMUM | MEAN | MEDIAN | MINIMUM}, {EXPAND | TRUNCATE}, {DATA | NODATA})
       
       Generates a reduced resolution version of a raster.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster.
         cell_factor (Long, Required): Cell factor
         aggregation_type (String, Optional): Aggregation technique
         extent_handling (Boolean, Optional): Expand extent if needed
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Aggregate_sa(*gp_fixargs((in_raster, cell_factor, aggregation_type, extent_handling, ignore_nodata), True)))

@gptooldoc('AreaSolarRadiation_sa', None)
def AreaSolarRadiation(in_surface_raster=None, latitude=None, sky_size=None, time_configuration=None, day_interval=None, hour_interval=None, each_interval=None, z_factor=None, slope_aspect_input_type=None, calculation_directions=None, zenith_divisions=None, azimuth_divisions=None, diffuse_model_type=None, diffuse_proportion=None, transmittivity=None, out_direct_radiation_raster=None, out_diffuse_radiation_raster=None, out_direct_duration_raster=None):
    """AreaSolarRadiation_sa(in_surface_raster, {latitude}, {sky_size}, {time_configuration}, {day_interval}, {hour_interval}, {NOINTERVAL | INTERVAL}, {z_factor}, {FROM_DEM | FLAT_SURFACE}, {calculation_directions}, {zenith_divisions}, {azimuth_divisions}, {UNIFORM_SKY | STANDARD_OVERCAST_SKY}, {diffuse_proportion}, {transmittivity}, {out_direct_radiation_raster}, {out_diffuse_radiation_raster}, {out_direct_duration_raster})
       
       Derives incoming solar radiation from a raster surface.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         latitude (Double, Optional): Latitude
         sky_size (Long, Optional): Sky size / Resolution
         time_configuration (Time configuration, Optional): Time configuration
         day_interval (Long, Optional): Day interval
         hour_interval (Double, Optional): Hour interval 
         each_interval (Boolean, Optional): Create outputs for each interval
         z_factor (Double, Optional): Z factor
         slope_aspect_input_type (String, Optional): Slope and aspect input type
         calculation_directions (Long, Optional): Calculation directions
         zenith_divisions (Long, Optional): Zenith divisions
         azimuth_divisions (Long, Optional): Azimuth divisions
         diffuse_model_type (String, Optional): Diffuse model type
         diffuse_proportion (Double, Optional): Diffuse proportion
         transmittivity (Double, Optional): Transmittivity
       OUTPUTS:
         out_direct_radiation_raster (Raster Dataset, Optional): Output direct radiation raster
         out_diffuse_radiation_raster (Raster Dataset, Optional): Output diffuse radiation raster
         out_direct_duration_raster (Raster Dataset, Optional): Output direct duration raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.AreaSolarRadiation_sa(*gp_fixargs((in_surface_raster, latitude, sky_size, time_configuration, day_interval, hour_interval, each_interval, z_factor, slope_aspect_input_type, calculation_directions, zenith_divisions, azimuth_divisions, diffuse_model_type, diffuse_proportion, transmittivity, out_direct_radiation_raster, out_diffuse_radiation_raster, out_direct_duration_raster), True)))

@gptooldoc('Aspect_sa', None)
def Aspect(in_raster=None):
    """Aspect_sa(in_raster)
       
       Derives aspect from a raster surface. Aspect identifies the downslope direction of the maximum rate of change in value from each cell to its neighbors. Aspect can be thought of as the slope direction. The values of the output raster will be the compass direction of the aspect.
       
       INPUT:
         in_raster (Composite Geodataset, Required): Input raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Aspect_sa(*gp_fixargs((in_raster, ), True)))

@gptooldoc('BandCollectionStats_sa', None)
def BandCollectionStats(in_raster_bands=None, out_stat_file=None, compute_matrices=None):
    """BandCollectionStats_sa([in_raster_band,...], out_stat_file, {BRIEF | DETAILED})
       
       Calculates the statistics for a set of raster bands.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         compute_matrices (Boolean, Optional): Compute covariance and correlation matrices
       OUTPUT:
         out_stat_file (File, Required): Output statistics file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BandCollectionStats_sa(*gp_fixargs((in_raster_bands, out_stat_file, compute_matrices), True)))

@gptooldoc('Basin_sa', None)
def Basin(in_flow_direction_raster=None):
    """Basin_sa(in_flow_direction_raster)
       
       Creates a raster delineating all drainage basins.
       
       INPUT:
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Basin_sa(*gp_fixargs((in_flow_direction_raster, ), True)))

@gptooldoc('BitwiseAnd_sa', None)
def BitwiseAnd(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BitwiseAnd_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Bitwise And operation on the binary values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseAnd_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BitwiseLeftShift_sa', None)
def BitwiseLeftShift(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BitwiseLeftShift_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Bitwise Left Shift operation on the binary values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseLeftShift_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BitwiseNot_sa', None)
def BitwiseNot(in_raster_or_constant=None):
    """BitwiseNot_sa(in_raster_or_constant)
       
       Performs a Bitwise Complement operation on the binary value of an input raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseNot_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('BitwiseOr_sa', None)
def BitwiseOr(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BitwiseOr_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Bitwise Or operation on the binary values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BitwiseRightShift_sa', None)
def BitwiseRightShift(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BitwiseRightShift_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Bitwise Right Shift operation on the binary values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseRightShift_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BitwiseXOr_sa', None)
def BitwiseXOr(in_raster_or_constant1=None, in_raster_or_constant2=None, out_raster=None):
    """BitwiseXOr_sa(in_raster_or_constant1, in_raster_or_constant2, out_raster)
       
       Performs a Bitwise Exclusive Or operation on the binary values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BitwiseXOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2, out_raster), True)))

@gptooldoc('BlockStatistics_sa', None)
def BlockStatistics(in_raster=None, neighborhood=None, statistics_type=None, ignore_nodata=None):
    """BlockStatistics_sa(in_raster, {neighborhood}, {MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY}, {DATA | NODATA})
       
       Calculates statistics for a non-overlapping neighborhood.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         neighborhood (Neighborhood, Optional): Neighborhood
         statistics_type (String, Optional): Statistics type
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BlockStatistics_sa(*gp_fixargs((in_raster, neighborhood, statistics_type, ignore_nodata), True)))

@gptooldoc('BooleanAnd_sa', None)
def BooleanAnd(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BooleanAnd_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Boolean And operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BooleanAnd_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BooleanNot_sa', None)
def BooleanNot(in_raster_or_constant=None):
    """BooleanNot_sa(in_raster_or_constant)
       
       Performs a Boolean complement (NOT) operation on the cell values of two input rasters.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BooleanNot_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('BooleanOr_sa', None)
def BooleanOr(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BooleanOr_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Boolean Or operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BooleanOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BooleanXOr_sa', None)
def BooleanXOr(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """BooleanXOr_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Boolean Exclusive Or operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BooleanXOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('BoundaryClean_sa', None)
def BoundaryClean(in_raster=None, sort_type=None, number_of_runs=None):
    """BoundaryClean_sa(in_raster, {NO_SORT | DESCEND | ASCEND}, {TWO_WAY | ONE_WAY})
       
       Smoothes the boundary between zones by expanding and shrinking it.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         sort_type (String, Optional): Sorting technique
         number_of_runs (Boolean, Optional): Run expansion and shrinking twice"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.BoundaryClean_sa(*gp_fixargs((in_raster, sort_type, number_of_runs), True)))

@gptooldoc('CellStatistics_sa', None)
def CellStatistics(in_rasters_or_constants=None, statistics_type=None):
    """CellStatistics_sa([in_raster_or_constant,...], MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY)
       
       Calculates a per-cell statistic from multiple rasters.
       
       INPUTS:
         in_rasters_or_constants (Composite Geodataset, Required): Input rasters or constant values
         statistics_type (String, Required): Overlay statistic"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CellStatistics_sa(*gp_fixargs((in_rasters_or_constants, statistics_type), True)))

@gptooldoc('ClassProbability_sa', None)
def ClassProbability(in_raster_bands=None, in_signature_file=None, maximum_output_value=None, a_priori_probabilities=None, in_a_priori_file=None):
    """ClassProbability_sa([in_raster_band,...], in_signature_file, {maximum_output_value}, {EQUAL | SAMPLE | FILE}, {in_a_priori_file})
       
       Creates probability layers for each class in a signature file.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         in_signature_file (File, Required): Input signature file
         maximum_output_value (Long, Optional): Maximum output value
         a_priori_probabilities (String, Optional): A priori probability weighting
         in_a_priori_file (File, Optional): Input a priori probability file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ClassProbability_sa(*gp_fixargs((in_raster_bands, in_signature_file, maximum_output_value, a_priori_probabilities, in_a_priori_file), True)))

@gptooldoc('CombinatorialAnd_sa', None)
def CombinatorialAnd(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """CombinatorialAnd_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Combinatorial And operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CombinatorialAnd_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('CombinatorialOr_sa', None)
def CombinatorialOr(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """CombinatorialOr_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Combinatorial Or operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CombinatorialOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('CombinatorialXOr_sa', None)
def CombinatorialXOr(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """CombinatorialXOr_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a Combinatorial Exclusive Or operation on the cell values of two input rasters.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CombinatorialXOr_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('Combine_sa', None)
def Combine(in_rasters=None):
    """Combine_sa([in_raster,...])
       
       Combines multiple rasters so a unique output value is assigned to each unique combination of input values.
       
       INPUT:
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Combine_sa(*gp_fixargs((in_rasters, ), True)))

@gptoolnotsupported
@gptooldoc('Con_sa', None)
def Con(in_conditional_raster=None, in_true_raster_or_constant=None, in_false_raster_or_constant=None, where_clause=None):
    """Con_sa(in_conditional_raster, in_true_raster_or_constant, {in_false_raster_or_constant}, {where_clause})
       
       Performs a conditional if/else evaluation on each of the input cells of an input raster.
       
       INPUTS:
         in_conditional_raster (Composite Geodataset, Required): Input conditional raster
         in_true_raster_or_constant (Composite Geodataset, Required): Input true raster or constant value
         in_false_raster_or_constant (Composite Geodataset, Optional): Input false raster or constant value
         where_clause (SQL Expression, Optional): Where clause"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Con_sa(*gp_fixargs((in_conditional_raster, in_true_raster_or_constant, in_false_raster_or_constant, where_clause), True)))

@gptooldoc('ContourList_sa', None)
def ContourList(in_raster=None, out_polyline_features=None, contour_values=None):
    """ContourList_sa(in_raster, out_polyline_features, [contour_value,...])
       
       Creates contours or isolines based on a list of contour values.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         contour_values (Double, Required): Contour values
       OUTPUT:
         out_polyline_features (Feature Class, Required): Output polyline features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ContourList_sa(*gp_fixargs((in_raster, out_polyline_features, contour_values), True)))

@gptooldoc('ContourWithBarriers_sa', None)
def ContourWithBarriers(in_raster=None, out_contour_feature_class=None, in_barrier_features=None, in_contour_type=None, in_contour_values_file=None, explicit_only=None, in_base_contour=None, in_contour_interval=None, in_indexed_contour_interval=None, in_contour_list=None, in_z_factor=None):
    """ContourWithBarriers_sa(in_raster, out_contour_feature_class, {in_barrier_features}, {POLYLINES | POLYGONS}, {in_contour_values_file}, {NO_EXPLICIT_VALUES_ONLY | EXPLICIT_VALUES_ONLY}, {in_base_contour}, {in_contour_interval}, {in_indexed_contour_interval}, {[contour_value,...]}, {in_z_factor})
       
       Creates contours from a raster surface. The inclusion of barrier features will allow one to independently generate contours on either side of a barrier.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_barrier_features (Feature Class, Optional): Input barrier features
         in_contour_type (Double, Optional): Input contour type
         in_contour_values_file (file, Optional): Input contour values file.
         explicit_only (String, Optional): Only specify explicit contour value.
         in_base_contour (Double, Optional): Base contour
         in_contour_interval (Double, Optional): Contour interval
         in_indexed_contour_interval (Double, Optional): Indexed Contour interval
         in_contour_list (Double, Optional): Contour values
         in_z_factor (Double, Optional): Z factor
       OUTPUT:
         out_contour_feature_class (Feature Class, Required): Output contour features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ContourWithBarriers_sa(*gp_fixargs((in_raster, out_contour_feature_class, in_barrier_features, in_contour_type, in_contour_values_file, explicit_only, in_base_contour, in_contour_interval, in_indexed_contour_interval, in_contour_list, in_z_factor), True)))

@gptooldoc('Contour_sa', None)
def Contour(in_raster=None, out_polyline_features=None, contour_interval=None, base_contour=None, z_factor=None):
    """Contour_sa(in_raster, out_polyline_features, contour_interval, {base_contour}, {z_factor})
       
       Creates contours or isolines from a raster surface.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         contour_interval (Double, Required): Contour interval
         base_contour (Double, Optional): Base contour
         z_factor (Double, Optional): Z factor
       OUTPUT:
         out_polyline_features (Feature Class, Required): Output polyline features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Contour_sa(*gp_fixargs((in_raster, out_polyline_features, contour_interval, base_contour, z_factor), True)))

@gptooldoc('Corridor_sa', None)
def Corridor(in_distance_raster1=None, in_distance_raster2=None):
    """Corridor_sa(in_distance_raster1, in_distance_raster2)
       
       Calculates the sum of accumulative costs for two input accumulative cost rasters.
       
       INPUTS:
         in_distance_raster1 (Composite Geodataset, Required): Input cost distance raster 1
         in_distance_raster2 (Composite Geodataset, Required): Input cost distance raster 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Corridor_sa(*gp_fixargs((in_distance_raster1, in_distance_raster2), True)))

@gptooldoc('CosH_sa', None)
def CosH(in_raster_or_constant=None):
    """CosH_sa(in_raster_or_constant)
       
       Calculates the hyperbolic cosine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CosH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Cos_sa', None)
def Cos(in_raster_or_constant=None):
    """Cos_sa(in_raster_or_constant)
       
       Calculates the cosine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Cos_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('CostAllocation_sa', None)
def CostAllocation(in_source_data=None, in_cost_raster=None, maximum_distance=None, in_value_raster=None, source_field=None, out_distance_raster=None, out_backlink_raster=None):
    """CostAllocation_sa(in_source_data, in_cost_raster, {maximum_distance}, {in_value_raster}, {source_field}, {out_distance_raster}, {out_backlink_raster})
       
       Calculates for each cell its nearest source based on the least accumulative cost over a cost surface.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         in_cost_raster (Composite Geodataset, Required): Input cost raster
         maximum_distance (Double, Optional): Maximum distance
         in_value_raster (Composite Geodataset, Optional): Input value raster
         source_field (Field, Optional): Source field
       OUTPUTS:
         out_distance_raster (Raster Dataset, Optional): Output distance raster
         out_backlink_raster (Raster Dataset, Optional): Output backlink raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CostAllocation_sa(*gp_fixargs((in_source_data, in_cost_raster, maximum_distance, in_value_raster, source_field, out_distance_raster, out_backlink_raster), True)))

@gptooldoc('CostBackLink_sa', None)
def CostBackLink(in_source_data=None, in_cost_raster=None, maximum_distance=None, out_distance_raster=None):
    """CostBackLink_sa(in_source_data, in_cost_raster, {maximum_distance}, {out_distance_raster})
       
       Defines the neighbor that is the next cell on the least accumulative cost path to the nearest source.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         in_cost_raster (Composite Geodataset, Required): Input cost raster
         maximum_distance (Double, Optional): Maximum distance
       OUTPUT:
         out_distance_raster (Raster Dataset, Optional): Output distance raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CostBackLink_sa(*gp_fixargs((in_source_data, in_cost_raster, maximum_distance, out_distance_raster), True)))

@gptooldoc('CostDistance_sa', None)
def CostDistance(in_source_data=None, in_cost_raster=None, maximum_distance=None, out_backlink_raster=None):
    """CostDistance_sa(in_source_data, in_cost_raster, {maximum_distance}, {out_backlink_raster})
       
       Calculates the least accumulative cost distance for each cell to the nearest source over a cost surface.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         in_cost_raster (Composite Geodataset, Required): Input cost raster
         maximum_distance (Double, Optional): Maximum distance
       OUTPUT:
         out_backlink_raster (Raster Dataset, Optional): Output backlink raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CostDistance_sa(*gp_fixargs((in_source_data, in_cost_raster, maximum_distance, out_backlink_raster), True)))

@gptooldoc('CostPath_sa', None)
def CostPath(in_destination_data=None, in_cost_distance_raster=None, in_cost_backlink_raster=None, path_type=None, destination_field=None):
    """CostPath_sa(in_destination_data, in_cost_distance_raster, in_cost_backlink_raster, {EACH_CELL | EACH_ZONE | BEST_SINGLE}, {destination_field})
       
       Calculates the least-cost path from a source to a destination.
       
       INPUTS:
         in_destination_data (Composite Geodataset, Required): Input raster or feature destination data
         in_cost_distance_raster (Composite Geodataset, Required): Input cost distance raster
         in_cost_backlink_raster (Composite Geodataset, Required): Input cost backlink raster
         path_type (String, Optional): Path type
         destination_field (Field, Optional): Destination field"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CostPath_sa(*gp_fixargs((in_destination_data, in_cost_distance_raster, in_cost_backlink_raster, path_type, destination_field), True)))

@gptooldoc('CreateConstantRaster_sa', None)
def CreateConstantRaster(out_raster=None, constant_value=None, data_type=None, cell_size=None, extent=None):
    """CreateConstantRaster_sa(out_raster, constant_value, {INTEGER | FLOAT}, {cell_size}, {extent})
       
       Creates a raster of a constant value within the Analysis window.
       
       INPUTS:
         constant_value (Double, Required): Constant value
         data_type (String, Optional): Output data type
         cell_size (Analysis cell size, Optional): Output cell size
         extent (Envelope, Optional): Output extent
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CreateConstantRaster_sa(*gp_fixargs((out_raster, constant_value, data_type, cell_size, extent), True)))

@gptooldoc('CreateNormalRaster_sa', None)
def CreateNormalRaster(out_raster=None, cell_size=None, extent=None):
    """CreateNormalRaster_sa(out_raster, {cell_size}, {extent})
       
       Creates a raster of random values with a normal distribution on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         cell_size (Analysis cell size, Optional): Output cell size
         extent (Envelope, Optional): Output extent
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CreateNormalRaster_sa(*gp_fixargs((out_raster, cell_size, extent), True)))

@gptooldoc('CreateRandomRaster_sa', None)
def CreateRandomRaster(out_raster=None, seed_value=None, cell_size=None, extent=None):
    """CreateRandomRaster_sa(out_raster, {seed_value}, {cell_size}, {extent})
       
       Creates a raster of random floating point values between 0 and 1 on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         seed_value (Double, Optional): Seed value
         cell_size (Analysis cell size, Optional): Output cell size
         extent (Envelope, Optional): Output extent
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CreateRandomRaster_sa(*gp_fixargs((out_raster, seed_value, cell_size, extent), True)))

@gptooldoc('CreateSignatures_sa', None)
def CreateSignatures(in_raster_bands=None, in_sample_data=None, out_signature_file=None, compute_covariance=None, sample_field=None):
    """CreateSignatures_sa([in_raster_band,...], in_sample_data, out_signature_file, {COVARIANCE | MEAN_ONLY}, {sample_field})
       
       Creates an ASCII signature file of classes defined by input sample data and a set of raster bands.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         in_sample_data (Composite Geodataset, Required): Input raster or feature sample data
         compute_covariance (Boolean, Optional): Compute covariance matrices
         sample_field (Field, Optional): Sample field
       OUTPUT:
         out_signature_file (File, Required): Output signature file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CreateSignatures_sa(*gp_fixargs((in_raster_bands, in_sample_data, out_signature_file, compute_covariance, sample_field), True)))

@gptooldoc('Curvature_sa', None)
def Curvature(in_raster=None, z_factor=None, out_profile_curve_raster=None, out_plan_curve_raster=None):
    """Curvature_sa(in_raster, {z_factor}, {out_profile_curve_raster}, {out_plan_curve_raster})
       
       Calculates the curvature of a raster surface, optionally including profile and plan curvature.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         z_factor (Double, Optional): Z factor
         out_profile_curve_raster (Raster Dataset, Optional): Output profile curve raster
         out_plan_curve_raster (Raster Dataset, Optional): Output plan curve raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Curvature_sa(*gp_fixargs((in_raster, z_factor, out_profile_curve_raster, out_plan_curve_raster), True)))

@gptooldoc('CutFill_sa', None)
def CutFill(in_before_surface=None, in_after_surface=None, z_factor=None):
    """CutFill_sa(in_before_surface, in_after_surface, {z_factor})
       
       Calculates the volume and area of cut and fill locations.
       
       INPUTS:
         in_before_surface (Composite Geodataset, Required): Input before raster surface
         in_after_surface (Composite Geodataset, Required): The input representing the surface after the cut or fill operation.
         z_factor (Double, Optional): Z factor"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.CutFill_sa(*gp_fixargs((in_before_surface, in_after_surface, z_factor), True)))

@gptooldoc('DarcyFlow_sa', None)
def DarcyFlow(in_head_raster=None, in_porosity_raster=None, in_thickness_raster=None, in_transmissivity_raster=None, out_direction_raster=None, out_magnitude_raster=None):
    """DarcyFlow_sa(in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, {out_direction_raster}, {out_magnitude_raster})
       
       Calculates the groundwater volume balance residual and other outputs for steady flow in an aquifer.
       
       INPUTS:
         in_head_raster (Composite Geodataset, Required): Input groundwater head elevation raster
         in_porosity_raster (Composite Geodataset, Required): Input effective formation porosity raster
         in_thickness_raster (Composite Geodataset, Required): Input saturated thickness raster
         in_transmissivity_raster (Composite Geodataset, Required): Input formation transmissivity raster
       OUTPUTS:
         out_direction_raster (Raster Dataset, Optional): Output direction raster
         out_magnitude_raster (Raster Dataset, Optional): Output magnitude raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.DarcyFlow_sa(*gp_fixargs((in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, out_direction_raster, out_magnitude_raster), True)))

@gptooldoc('DarcyVelocity_sa', None)
def DarcyVelocity(in_head_raster=None, in_porosity_raster=None, in_thickness_raster=None, in_transmissivity_raster=None, out_magnitude_raster=None):
    """DarcyVelocity_sa(in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, out_magnitude_raster)
       
       Calculates the groundwater seepage velocity vector (direction and magnitude) for steady flow in an aquifer.
       
       INPUTS:
         in_head_raster (Composite Geodataset, Required): Input groundwater head elevation raster
         in_porosity_raster (Composite Geodataset, Required): Input effective formation porosity raster
         in_thickness_raster (Composite Geodataset, Required): Input saturated thickness raster
         in_transmissivity_raster (Composite Geodataset, Required): Input formation transmissivity raster
       OUTPUT:
         out_magnitude_raster (Raster Dataset, Required): Output magnitude raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.DarcyVelocity_sa(*gp_fixargs((in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, out_magnitude_raster), True)))

@gptoolnotsupported
@gptooldoc('Dendrogram_sa', None)
def Dendrogram(in_signature_file=None, out_dendrogram_file=None, distance_calculation=None, line_width=None):
    """Dendrogram_sa(in_signature_file, out_dendrogram_file, {VARIANCE | MEAN_ONLY}, {line_width})
       
       Constructs a tree diagram showing attribute distances between sequentially merged classes in a signature file.
       
       INPUTS:
         in_signature_file (File, Required): Input signature file
         distance_calculation (Boolean, Optional): Use variance in distance calculations
         line_width (Long, Optional): Line width of dendrogram
       OUTPUT:
         out_dendrogram_file (File, Required): Output dendrogram file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Dendrogram_sa(*gp_fixargs((in_signature_file, out_dendrogram_file, distance_calculation, line_width), True)))

@gptooldoc('Diff_sa', None)
def Diff(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Diff_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Determines which values from the first input are logically different from the values of the second input on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Diff_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('Divide_sa', None)
def Divide(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Divide_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Divides the values of two rasters on a cell-by-cell basis.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Divide_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('EditSignatures_sa', None)
def EditSignatures(in_raster_bands=None, in_signature_file=None, in_signature_remap_file=None, out_signature_file=None, sample_interval=None):
    """EditSignatures_sa([in_raster_band,...], in_signature_file, in_signature_remap_file, out_signature_file, {sample_interval})
       
       Edits and updates a signature file by merging, renumbering, and deleting class signatures.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         in_signature_file (File, Required): Input signature file
         in_signature_remap_file (File, Required): Input signature remap file
         sample_interval (Long, Optional): Sample interval
       OUTPUT:
         out_signature_file (File, Required): Output signature file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EditSignatures_sa(*gp_fixargs((in_raster_bands, in_signature_file, in_signature_remap_file, out_signature_file, sample_interval), True)))

@gptooldoc('EqualToFrequency_sa', None)
def EqualToFrequency(in_value_raster=None, in_rasters=None):
    """EqualToFrequency_sa(in_value_raster, [in_raster,...])
       
       Evaluates the number of times a set of rasters is equal to another raster on a cell-by-cell basis.
       
       INPUTS:
         in_value_raster (Composite Geodataset, Required): Input value raster
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EqualToFrequency_sa(*gp_fixargs((in_value_raster, in_rasters), True)))

@gptooldoc('EqualTo_sa', None)
def EqualTo(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """EqualTo_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Performs a relational equal-to operation on two inputs on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EqualTo_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('EucAllocation_sa', None)
def EucAllocation(in_source_data=None, maximum_distance=None, in_value_raster=None, cell_size=None, source_field=None, out_distance_raster=None, out_direction_raster=None):
    """EucAllocation_sa(in_source_data, {maximum_distance}, {in_value_raster}, {cell_size}, {source_field}, {out_distance_raster}, {out_direction_raster})
       
       Calculates, for each cell, the nearest source based on Euclidean distance.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         maximum_distance (Double, Optional): Maximum distance
         in_value_raster (Composite Geodataset, Optional): Input value raster
         cell_size (Analysis cell size, Optional): Output cell size
         source_field (Field, Optional): Source field
       OUTPUTS:
         out_distance_raster (Raster Dataset, Optional): Output distance raster
         out_direction_raster (Raster Dataset, Optional): Output direction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EucAllocation_sa(*gp_fixargs((in_source_data, maximum_distance, in_value_raster, cell_size, source_field, out_distance_raster, out_direction_raster), True)))

@gptooldoc('EucDirection_sa', None)
def EucDirection(in_source_data=None, maximum_distance=None, cell_size=None, out_distance_raster=None):
    """EucDirection_sa(in_source_data, {maximum_distance}, {cell_size}, {out_distance_raster})
       
       Calculates, for each cell, the direction, in degrees, to the nearest source.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         maximum_distance (Double, Optional): Maximum distance
         cell_size (Analysis cell size, Optional): Output cell size
       OUTPUT:
         out_distance_raster (Raster Dataset, Optional): Output distance raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EucDirection_sa(*gp_fixargs((in_source_data, maximum_distance, cell_size, out_distance_raster), True)))

@gptooldoc('EucDistance_sa', None)
def EucDistance(in_source_data=None, maximum_distance=None, cell_size=None, out_direction_raster=None):
    """EucDistance_sa(in_source_data, {maximum_distance}, {cell_size}, {out_direction_raster})
       
       Calculates, for each cell, the Euclidean distance to the closest source.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         maximum_distance (Double, Optional): Maximum distance
         cell_size (Analysis cell size, Optional): Output cell size
       OUTPUT:
         out_direction_raster (Raster Dataset, Optional): Output direction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.EucDistance_sa(*gp_fixargs((in_source_data, maximum_distance, cell_size, out_direction_raster), True)))

@gptooldoc('Exp10_sa', None)
def Exp10(in_raster_or_constant=None):
    """Exp10_sa(in_raster_or_constant)
       
       Calculates the base 10 exponential of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Exp10_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Exp2_sa', None)
def Exp2(in_raster_or_constant=None):
    """Exp2_sa(in_raster_or_constant)
       
       Calculates the base 2 exponential of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Exp2_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Exp_sa', None)
def Exp(in_raster_or_constant=None):
    """Exp_sa(in_raster_or_constant)
       
       Calculates the base e exponential of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Exp_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Expand_sa', None)
def Expand(in_raster=None, number_cells=None, zone_values=None):
    """Expand_sa(in_raster, number_cells, [zone_value,...])
       
       Expands specified zones of a raster by a specified number of cells.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         number_cells (Long, Required): Number of cells
         zone_values (Long, Required): Zone values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Expand_sa(*gp_fixargs((in_raster, number_cells, zone_values), True)))

@gptooldoc('ExtractByAttributes_sa', None)
def ExtractByAttributes(in_raster=None, where_clause=None):
    """ExtractByAttributes_sa(in_raster, where_clause)
       
       Extracts the cells of a raster based on a logical query.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): in_raster
         where_clause (SQL Expression, Required): Where clause"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByAttributes_sa(*gp_fixargs((in_raster, where_clause), True)))

@gptooldoc('ExtractByCircle_sa', None)
def ExtractByCircle(in_raster=None, center_point=None, radius=None, extraction_area=None):
    """ExtractByCircle_sa(in_raster, center_point, radius, {INSIDE | OUTSIDE})
       
       Extracts the cells of a raster based on a circle.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         center_point (Point, Required): Center point
         radius (Double, Required): Radius
         extraction_area (String, Optional): Extraction area"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByCircle_sa(*gp_fixargs((in_raster, center_point, radius, extraction_area), True)))

@gptooldoc('ExtractByMask_sa', None)
def ExtractByMask(in_raster=None, in_mask_data=None):
    """ExtractByMask_sa(in_raster, in_mask_data)
       
       Extracts the cells of a raster that correspond to the areas defined by a mask.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_mask_data (Composite Geodataset, Required): Input raster or feature mask data"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByMask_sa(*gp_fixargs((in_raster, in_mask_data), True)))

@gptooldoc('ExtractByPoints_sa', None)
def ExtractByPoints(in_raster=None, points=None, extraction_area=None):
    """ExtractByPoints_sa(in_raster, [point,...], {INSIDE | OUTSIDE})
       
       Extracts the cells of a raster based on a set of points.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         points (Point, Required): Input points
         extraction_area (String, Optional): Extraction area"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByPoints_sa(*gp_fixargs((in_raster, points, extraction_area), True)))

@gptooldoc('ExtractByPolygon_sa', None)
def ExtractByPolygon(in_raster=None, polygon=None, extraction_area=None):
    """ExtractByPolygon_sa(in_raster, [polygon,...], {INSIDE | OUTSIDE})
       
       Extracts the cells of a raster based on a polygon.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         polygon (Point, Required): Polygon
         extraction_area (String, Optional): Extraction area"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByPolygon_sa(*gp_fixargs((in_raster, polygon, extraction_area), True)))

@gptooldoc('ExtractByRectangle_sa', None)
def ExtractByRectangle(in_raster=None, rectangle=None, extraction_area=None):
    """ExtractByRectangle_sa(in_raster, rectangle, {INSIDE | OUTSIDE})
       
       Extracts the cells of a raster based on a rectangle.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         rectangle (Envelope, Required): Rectangle
         extraction_area (String, Optional): Extraction area"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractByRectangle_sa(*gp_fixargs((in_raster, rectangle, extraction_area), True)))

@gptooldoc('ExtractValuesToPoints_sa', None)
def ExtractValuesToPoints(in_point_features=None, in_raster=None, out_point_features=None, interpolate_values=None, add_attributes=None):
    """ExtractValuesToPoints_sa(in_point_features, in_raster, out_point_features, {NONE | INTERPOLATE}, {VALUE_ONLY | ALL})
       
       Extracts the cell values of a raster based on a set of points.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         in_raster (Composite Geodataset, Required): Input raster
         interpolate_values (Boolean, Optional): Interpolate values at the point locations
         add_attributes (Boolean, Optional): Append all the input raster attributes to the output point features
       OUTPUT:
         out_point_features (Feature Class, Required): Output point features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ExtractValuesToPoints_sa(*gp_fixargs((in_point_features, in_raster, out_point_features, interpolate_values, add_attributes), True)))

@gptooldoc('Fill_sa', None)
def Fill(in_surface_raster=None, z_limit=None):
    """Fill_sa(in_surface_raster, {z_limit})
       
       Fills sinks in a surface raster to remove small imperfections in the data.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         z_limit (Double, Optional): Z limit"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Fill_sa(*gp_fixargs((in_surface_raster, z_limit), True)))

@gptooldoc('Filter_sa', None)
def Filter(in_raster=None, filter_type=None, ignore_nodata=None):
    """Filter_sa(in_raster, {LOW | HIGH}, {DATA | NODATA})
       
       Performs a preset focal filter on a raster.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         filter_type (String, Optional): Filter type
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Filter_sa(*gp_fixargs((in_raster, filter_type, ignore_nodata), True)))

@gptooldoc('Float_sa', None)
def Float(in_raster_or_constant=None):
    """Float_sa(in_raster_or_constant)
       
       Converts each cell value of a raster into a floating-point representation.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Float_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('FlowAccumulation_sa', None)
def FlowAccumulation(in_flow_direction_raster=None, in_weight_raster=None, data_type=None):
    """FlowAccumulation_sa(in_flow_direction_raster, {in_weight_raster}, {FLOAT | INTEGER})
       
       Creates a raster of accumulated flow to each cell.
       
       INPUTS:
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster
         in_weight_raster (Composite Geodataset, Optional): Input weight raster
       OUTPUT:
         data_type (boolean, Optional): Data type"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.FlowAccumulation_sa(*gp_fixargs((in_flow_direction_raster, in_weight_raster, data_type), True)))

@gptooldoc('FlowDirection_sa', None)
def FlowDirection(in_surface_raster=None, force_flow=None, out_drop_raster=None):
    """FlowDirection_sa(in_surface_raster, {NORMAL | FORCE}, {out_drop_raster})
       
       Creates a raster of flow direction from each cell to its steepest downslope neighbor.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         force_flow (Boolean, Optional): Force all edge cells to flow outward
       OUTPUT:
         out_drop_raster (Raster Dataset, Optional): Output drop raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.FlowDirection_sa(*gp_fixargs((in_surface_raster, force_flow, out_drop_raster), True)))

@gptooldoc('FlowLength_sa', None)
def FlowLength(in_flow_direction_raster=None, direction_measurement=None, in_weight_raster=None):
    """FlowLength_sa(in_flow_direction_raster, {DOWNSTREAM | UPSTREAM}, {in_weight_raster})
       
       Calculates distance or weighted distance along a flow path.
       
       INPUTS:
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster
         direction_measurement (String, Optional): Direction of measurement
         in_weight_raster (Composite Geodataset, Optional): Input weight raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.FlowLength_sa(*gp_fixargs((in_flow_direction_raster, direction_measurement, in_weight_raster), True)))

@gptooldoc('FocalFlow_sa', None)
def FocalFlow(in_surface_raster=None, threshold_value=None):
    """FocalFlow_sa(in_surface_raster, {threshold_value})
       
       Determines the flow of the values in the input raster within each cell's immediate neighborhood.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         threshold_value (Double, Optional): Threshold value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.FocalFlow_sa(*gp_fixargs((in_surface_raster, threshold_value), True)))

@gptooldoc('FocalStatistics_sa', None)
def FocalStatistics(in_raster=None, neighborhood=None, statistics_type=None, ignore_nodata=None):
    """FocalStatistics_sa(in_raster, {neighborhood}, {MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY}, {DATA | NODATA})
       
       Calculates a statistic on a raster over a specified neighborhood.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         neighborhood (Neighborhood, Optional): Neighborhood
         statistics_type (String, Optional): Statistics type
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.FocalStatistics_sa(*gp_fixargs((in_raster, neighborhood, statistics_type, ignore_nodata), True)))

@gptooldoc('GreaterThanEqual_sa', None)
def GreaterThanEqual(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """GreaterThanEqual_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Returns 1 for cells where the first raster is greater than or equal to the second raster and 0 if it is not.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.GreaterThanEqual_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('GreaterThanFrequency_sa', None)
def GreaterThanFrequency(in_value_raster=None, in_rasters=None):
    """GreaterThanFrequency_sa(in_value_raster, [in_raster,...])
       
       Evaluates the number of times a set of rasters is greater than another raster on a cell-by-cell basis.
       
       INPUTS:
         in_value_raster (Composite Geodataset, Required): Input value raster
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.GreaterThanFrequency_sa(*gp_fixargs((in_value_raster, in_rasters), True)))

@gptooldoc('GreaterThan_sa', None)
def GreaterThan(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """GreaterThan_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Returns 1 for cells where the first raster is greater than the second raster and 0 for cells if it is not.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.GreaterThan_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('HighestPosition_sa', None)
def HighestPosition(in_rasters_or_constants=None):
    """HighestPosition_sa([in_raster_or_constant,...])
       
       Determines the position of a raster with the maximum value in a set of rasters.
       
       INPUT:
         in_rasters_or_constants (Composite Geodataset, Required): Input rasters or constant values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.HighestPosition_sa(*gp_fixargs((in_rasters_or_constants, ), True)))

@gptooldoc('HillShade_sa', None)
def HillShade(in_raster=None, azimuth=None, altitude=None, model_shadows=None, z_factor=None):
    """HillShade_sa(in_raster, {azimuth}, {altitude}, {NO_SHADOWS | SHADOWS}, {z_factor})
       
       Computes hillshade values for a raster surface by considering the illumination angle and shadows.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         azimuth (Double, Optional): Azimuth
         altitude (Double, Optional): Altitude
         model_shadows (Boolean, Optional): Model shadows
         z_factor (Double, Optional): Z factor"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.HillShade_sa(*gp_fixargs((in_raster, azimuth, altitude, model_shadows, z_factor), True)))

@gptooldoc('Idw_sa', None)
def Idw(in_point_features=None, z_field=None, cell_size=None, power=None, search_radius=None, in_barrier_polyline_features=None):
    """Idw_sa(in_point_features, z_field, {cell_size}, {power}, {search_radius}, {in_barrier_polyline_features})
       
       Interpolates a surface from points using an inverse distance weighted (IDW) technique.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         z_field (Field, Required): Z value field
         cell_size (Analysis cell size, Optional): Output cell size
         power (Double, Optional): Power
         search_radius (Radius, Optional): Search radius
         in_barrier_polyline_features (Composite Geodataset, Optional): Input barrier polyline features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Idw_sa(*gp_fixargs((in_point_features, z_field, cell_size, power, search_radius, in_barrier_polyline_features), True)))

@gptooldoc('InList_sa', None)
def InList(in_raster_or_constant=None, in_raster_or_constants=None):
    """InList_sa(in_raster_or_constant, [raster_or_constant,...])
       
       Determines which values from the first input are contained in the other inputs, on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value
         in_raster_or_constants (Composite Geodataset, Required): Input rasters or constant values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.InList_sa(*gp_fixargs((in_raster_or_constant, in_raster_or_constants), True)))

@gptooldoc('Int_sa', None)
def Int(in_raster_or_constant=None):
    """Int_sa(in_raster_or_constant)
       
       Converts each cell value of a raster to an integer by truncation.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Int_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('IsNull_sa', None)
def IsNull(in_raster=None):
    """IsNull_sa(in_raster)
       
       Returns 1 if the input value is NoData and 0 for cells that are not, on a cell-by-cell basis within the Analysis window.
       
       INPUT:
         in_raster (Composite Geodataset, Required): Input raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.IsNull_sa(*gp_fixargs((in_raster, ), True)))

@gptooldoc('IsoCluster_sa', None)
def IsoCluster(in_raster_bands=None, out_signature_file=None, number_classes=None, number_iterations=None, min_class_size=None, sample_interval=None):
    """IsoCluster_sa([in_raster_band,...], out_signature_file, number_classes, {number_iterations}, {min_class_size}, {sample_interval})
       
       Uses an isodata clustering algorithm to determine the characteristics of the natural groupings of cells in multidimensional attribute space and stores the results in an output ASCII signature file.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         number_classes (Long, Required): Number of classes
         number_iterations (Long, Optional): Number of iterations
         min_class_size (Long, Optional): Minimum class size
         sample_interval (Long, Optional): Sample interval
       OUTPUT:
         out_signature_file (File, Required): Output signature file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.IsoCluster_sa(*gp_fixargs((in_raster_bands, out_signature_file, number_classes, number_iterations, min_class_size, sample_interval), True)))

@gptooldoc('KernelDensity_sa', None)
def KernelDensity(in_features=None, population_field=None, cell_size=None, search_radius=None, area_unit_scale_factor=None):
    """KernelDensity_sa(in_features, population_field, {cell_size}, {search_radius}, {SQUARE_MAP_UNITS | SQUARE_MILES | SQUARE_KILOMETERS | ACRES | HECTARES | SQUARE_YARDS | SQUARE_FEET | SQUARE_INCHES | SQUARE_METERS | SQUARE_CENTIMETERS | SQUARE_MILLIMETERS})
       
       Calculates a magnitude per unit area from point or polyline features using a kernel function to fit a smoothly tapered surface to each point or polyline.
       
       INPUTS:
         in_features (Composite Geodataset, Required): Input point or polyline features
         population_field (Field, Required): Population Field
         cell_size (Analysis cell size, Optional): Output cell size
         search_radius (Double, Optional): Search radius
         area_unit_scale_factor (String, Optional): Area units"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.KernelDensity_sa(*gp_fixargs((in_features, population_field, cell_size, search_radius, area_unit_scale_factor), True)))

@gptooldoc('Kriging_sa', None)
def Kriging(in_point_features=None, z_field=None, semiVariogram_props=None, Lag_size_Major_range_Partial_sill_Nugget=None, cell_size=None, search_radius=None, out_variance_prediction_raster=None):
    """Kriging_sa(in_point_features, z_field, SPHERICAL | CIRCULAR | EXPONENTIAL | GAUSSIAN | LINEAR | LINEARDRIFT | QUADRATICDRIFT | NONE, {Lag size} {Major range} {Partial sill} {Nugget}, {cell_size}, {search_radius}, {out_variance_prediction_raster})
       
       Interpolates a surface from points using kriging.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         z_field (Field, Required): Z value field
         semiVariogram_props (SemiVariogram, Required): Semivariogram properties
         {Lag size} {Major range} {Partial sill} {Nugget} (, Optional): Semivariogram properties
         cell_size (Analysis cell size, Optional): Output cell size
         search_radius (Radius, Optional): Search radius
         out_variance_prediction_raster (Raster Dataset, Optional): Output variance of prediction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Kriging_sa(*gp_fixargs((in_point_features, z_field, semiVariogram_props, Lag_size_Major_range_Partial_sill_Nugget, cell_size, search_radius, out_variance_prediction_raster), True)))

@gptooldoc('LessThanEqual_sa', None)
def LessThanEqual(in_raster_or_constant1=None, in_raster_or_constant2=None, out_raster=None):
    """LessThanEqual_sa(in_raster_or_constant1, in_raster_or_constant2, out_raster)
       
       Returns 1 for cells where the first raster is less than or equal to the second raster and 0 where it is not.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LessThanEqual_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2, out_raster), True)))

@gptooldoc('LessThanFrequency_sa', None)
def LessThanFrequency(in_value_raster=None, in_rasters=None):
    """LessThanFrequency_sa(in_value_raster, [in_raster,...])
       
       Evaluates the number of times a set of rasters is less than another raster on a cell-by-cell basis.
       
       INPUTS:
         in_value_raster (Composite Geodataset, Required): Input value raster
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LessThanFrequency_sa(*gp_fixargs((in_value_raster, in_rasters), True)))

@gptooldoc('LessThan_sa', None)
def LessThan(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """LessThan_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Returns 1 for cells where the first raster is less than the second raster and 0 if it is not.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LessThan_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('LineDensity_sa', None)
def LineDensity(in_polyline_features=None, population_field=None, cell_size=None, search_radius=None, area_unit_scale_factor=None):
    """LineDensity_sa(in_polyline_features, population_field, {cell_size}, {search_radius}, {SQUARE_MAP_UNITS | SQUARE_MILES | SQUARE_KILOMETERS | ACRES | HECTARES | SQUARE_YARDS | SQUARE_FEET | SQUARE_INCHES | SQUARE_METERS | SQUARE_CENTIMETERS | SQUARE_MILLIMETERS})
       
       Calculates a magnitude per unit area from polyline features that fall within a radius around each cell.
       
       INPUTS:
         in_polyline_features (Composite Geodataset, Required): Input polyline features
         population_field (Field, Required): Population field
         cell_size (Analysis cell size, Optional): Output cell size
         search_radius (Double, Optional): Search radius
         area_unit_scale_factor (String, Optional): Area units"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LineDensity_sa(*gp_fixargs((in_polyline_features, population_field, cell_size, search_radius, area_unit_scale_factor), True)))

@gptooldoc('LineStatistics_sa', None)
def LineStatistics(in_polyline_features=None, field=None, cell_size=None, search_radius=None, statistics_type=None):
    """LineStatistics_sa(in_polyline_features, field, {cell_size}, {search_radius}, {MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | VARIETY})
       
       Calculates a statistic on the attributes of lines in a circular neighborhood around each output cell.
       
       INPUTS:
         in_polyline_features (Composite Geodataset, Required): Input polyline features
         field (Field, Required): Field
         cell_size (Analysis cell size, Optional): Cell size
         search_radius (Double, Optional): Search radius
         statistics_type (String, Optional): Overlay statistic"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LineStatistics_sa(*gp_fixargs((in_polyline_features, field, cell_size, search_radius, statistics_type), True)))

@gptooldoc('Ln_sa', None)
def Ln(in_raster_or_constant=None):
    """Ln_sa(in_raster_or_constant)
       
       Calculates the natural logarithm (base e) of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Ln_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Log10_sa', None)
def Log10(in_raster_or_constant=None):
    """Log10_sa(in_raster_or_constant)
       
       Calculates the base 10 logarithm of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Log10_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Log2_sa', None)
def Log2(in_raster_or_constant=None):
    """Log2_sa(in_raster_or_constant)
       
       Calculates the base 2 logarithm of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Log2_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Lookup_sa', None)
def Lookup(in_raster=None, lookup_field=None):
    """Lookup_sa(in_raster, lookup_field)
       
       Creates a new raster by looking up values found in another field in the table of the input raster.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         lookup_field (Field, Required): Lookup field"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Lookup_sa(*gp_fixargs((in_raster, lookup_field), True)))

@gptooldoc('LowestPosition_sa', None)
def LowestPosition(in_rasters_or_constants=None):
    """LowestPosition_sa([in_raster_or_constant,...])
       
       Determines the position of a raster with the minimum value in a set of rasters.
       
       INPUT:
         in_rasters_or_constants (Composite Geodataset, Required): Input rasters or constant values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.LowestPosition_sa(*gp_fixargs((in_rasters_or_constants, ), True)))

@gptooldoc('MLClassify_sa', None)
def MLClassify(in_raster_bands=None, in_signature_file=None, reject_fraction=None, a_priori_probabilities=None, in_a_priori_file=None, out_confidence_raster=None):
    """MLClassify_sa([in_raster_band,...], in_signature_file, {0.0 | 0.005 | 0.01 | 0.025 | 0.05 | 0.1 | 0.25 | 0.5 | 0.75 | 0.9 | 0.95 | 0.975 | 0.99 | 0.995}, {EQUAL | SAMPLE | FILE}, {in_a_priori_file}, {out_confidence_raster})
       
       Performs a maximum likelihood classification on a set of raster bands.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         reject_fraction (String, Optional): Reject fraction
         a_priori_probabilities (String, Optional): A priori probability weighting
         in_a_priori_file (File, Optional): Input a priori probability file
       OUTPUTS:
         in_signature_file (File, Required): Input signature file
         out_confidence_raster (Raster Dataset, Optional): Output confidence raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.MLClassify_sa(*gp_fixargs((in_raster_bands, in_signature_file, reject_fraction, a_priori_probabilities, in_a_priori_file, out_confidence_raster), True)))

@gptooldoc('MajorityFilter_sa', None)
def MajorityFilter(in_raster=None, number_neighbors=None, majority_definition=None):
    """MajorityFilter_sa(in_raster, {FOUR | EIGHT}, {MAJORITY | HALF})
       
       Replaces cells in a raster based on the majority of their contiguous neighboring cells.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         number_neighbors (String, Optional): Number of neighbors to use
         majority_definition (String, Optional): Replacement threshold"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.MajorityFilter_sa(*gp_fixargs((in_raster, number_neighbors, majority_definition), True)))

@gptooldoc('Minus_sa', None)
def Minus(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Minus_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Subtracts the value of the second input raster from the value of the first input raster on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Minus_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('Mod_sa', None)
def Mod(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Mod_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Finds the remainder (modulo) of the first raster when divided by the second raster on a cell-by-cell basis.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Mod_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptoolnotsupported
@gptooldoc('MultiOutputMapAlgebra_sa', None)
def MultiOutputMapAlgebra(expression_string=None):
    """MultiOutputMapAlgebra_sa(expression_string)
       
       Runs an expression built with the Map Algebra language.
       
       INPUT:
         expression_string (MapAlgebra Expression, Required): Map Algebra expression"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.MultiOutputMapAlgebra_sa(*gp_fixargs((expression_string, ), True)))

@gptooldoc('NaturalNeighbor_sa', None)
def NaturalNeighbor(in_point_features=None, z_field=None, cell_size=None):
    """NaturalNeighbor_sa(in_point_features, z_field, {cell_size})
       
       Interpolates a surface from points using a natural neighbor technique.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         z_field (Field, Required): Z value field
         cell_size (Analysis cell size, Optional): Output cell size"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.NaturalNeighbor_sa(*gp_fixargs((in_point_features, z_field, cell_size), True)))

@gptooldoc('Negate_sa', None)
def Negate(in_raster_or_constant=None):
    """Negate_sa(in_raster_or_constant)
       
       Changes the sign (multiplies by -1) of the cell values of the input raster on a cell-by-cell basis within the Analysis window.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Negate_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Nibble_sa', None)
def Nibble(in_raster=None, in_mask_raster=None, nibble_values=None):
    """Nibble_sa(in_raster, in_mask_raster, {ALL_VALUES | DATA_ONLY})
       
       Replaces cells of a raster corresponding to a mask with the values of the nearest neighbors.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_mask_raster (Composite Geodataset, Required): Input raster mask
         nibble_values (Boolean, Optional): Use NoData values if they are the nearest neighbor"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Nibble_sa(*gp_fixargs((in_raster, in_mask_raster, nibble_values), True)))

@gptooldoc('NotEqual_sa', None)
def NotEqual(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """NotEqual_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Returns 1 for cells where the first raster is not equal to the second raster and 0 for cells where it is equal.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.NotEqual_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('ObserverPoints_sa', None)
def ObserverPoints(in_raster=None, in_observer_point_features=None, z_factor=None, curvature_correction=None, refractivity_coefficient=None):
    """ObserverPoints_sa(in_raster, in_observer_point_features, {z_factor}, {FLAT_EARTH | CURVED_EARTH}, {refractivity_coefficient})
       
       Identifies exactly which observer points are visible from each raster surface location.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_observer_point_features (Composite Geodataset, Required): Input point observer features
         z_factor (Double, Optional): Z factor
         curvature_correction (Boolean, Optional): Use earth curvature corrections
         refractivity_coefficient (Double, Optional): Refractivity coefficient"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ObserverPoints_sa(*gp_fixargs((in_raster, in_observer_point_features, z_factor, curvature_correction, refractivity_coefficient), True)))

@gptooldoc('Over_sa', None)
def Over(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Over_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Returns those values from the first input that are non-zero; otherwise, returns the value from the second input on a cell-by-cell basis within the Analysis window.
       
       INPUT:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
       OUTPUT:
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Over_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('ParticleTrack_sa', None)
def ParticleTrack(in_direction_raster=None, in_magnitude_raster=None, source_point=None, out_track_file=None, step_length=None, tracking_time=None, out_track_polyline_features=None):
    """ParticleTrack_sa(in_direction_raster, in_magnitude_raster, source_point, out_track_file, {step_length}, {tracking_time}, {out_track_polyline_features})
       
       Calculates the path of a particle through a velocity field, returning an ASCII file of particle tracking data and, optionally, a coverage of track information.
       
       INPUTS:
         in_direction_raster (Composite Geodataset, Required): Input direction raster
         in_magnitude_raster (Composite Geodataset, Required): Input magnitude raster
         source_point (Point, Required): Source point
         step_length (Double, Optional): Step length
         tracking_time (Double, Optional): Tracking time
       OUTPUTS:
         out_track_file (File, Required): Output particle track file
         out_track_polyline_features (Feature Class, Optional): Output track polyline features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ParticleTrack_sa(*gp_fixargs((in_direction_raster, in_magnitude_raster, source_point, out_track_file, step_length, tracking_time, out_track_polyline_features), True)))

@gptooldoc('PathAllocation_sa', None)
def PathAllocation(in_source_data=None, source_field=None, in_cost_raster=None, in_surface_raster=None, in_horizontal_raster=None, horizontal_factor=None, in_vertical_raster=None, vertical_factor=None, maximum_distance=None, in_value_raster=None, out_distance_raster=None, out_backlink_raster=None):
    """PathAllocation_sa(in_source_data, {source_field}, {in_cost_raster}, {in_surface_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor}, {maximum_distance}, {in_value_raster}, {out_distance_raster}, {out_backlink_raster})
       
       Calculates the nearest source for each cell based on the least accumulative cost over a cost surface, while accounting for surface distance and horizontal and vertical cost factors.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         source_field (Field, Optional): Source field
         in_cost_raster (Composite Geodataset, Optional): Input cost raster
         in_surface_raster (Composite Geodataset, Optional): Input surface raster
         in_horizontal_raster (Composite Geodataset, Optional): Input horizontal raster
         horizontal_factor (Horizontal factor, Optional): Horizontal factor
         in_vertical_raster (Composite Geodataset, Optional): Input vertical raster
         vertical_factor (Vertical factor, Optional): Vertical factor
         maximum_distance (Double, Optional): Maximum distance
         in_value_raster (Composite Geodataset, Optional): Input value raster
       OUTPUTS:
         out_distance_raster (Raster Dataset, Optional): Output distance raster
         out_backlink_raster (Raster Dataset, Optional): Output backlink raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PathAllocation_sa(*gp_fixargs((in_source_data, source_field, in_cost_raster, in_surface_raster, in_horizontal_raster, horizontal_factor, in_vertical_raster, vertical_factor, maximum_distance, in_value_raster, out_distance_raster, out_backlink_raster), True)))

@gptooldoc('PathBackLink_sa', None)
def PathBackLink(in_source_data=None, out_backlink_raster=None, in_cost_raster=None, in_surface_raster=None, maximum_distance=None, out_distance_raster=None, in_horizontal_raster=None, horizontal_factor=None, in_vertical_raster=None, vertical_factor=None):
    """PathBackLink_sa(in_source_data, out_backlink_raster, {in_cost_raster}, {in_surface_raster}, {maximum_distance}, {out_distance_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor})
       
       Defines the neighbor that is the next cell on the least accumulative cost path to the nearest source, while accounting for surface distance and horizontal and vertical cost factors.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         in_cost_raster (Composite Geodataset, Optional): Input cost raster
         in_surface_raster (Composite Geodataset, Optional): Input surface raster
         maximum_distance (Double, Optional): Maximum distance
         in_horizontal_raster (Composite Geodataset, Optional): Input horizontal raster
         horizontal_factor (Horizontal factor, Optional): Horizontal factor
         in_vertical_raster (Composite Geodataset, Optional): Input vertical raster
         vertical_factor (Vertical factor, Optional): Vertical factor
       OUTPUTS:
         out_backlink_raster (Raster Dataset, Required): Output backlink raster
         out_distance_raster (Raster Dataset, Optional): Output distance raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PathBackLink_sa(*gp_fixargs((in_source_data, out_backlink_raster, in_cost_raster, in_surface_raster, maximum_distance, out_distance_raster, in_horizontal_raster, horizontal_factor, in_vertical_raster, vertical_factor), True)))

@gptooldoc('PathDistance_sa', None)
def PathDistance(in_source_data=None, in_cost_raster=None, in_surface_raster=None, in_horizontal_raster=None, horizontal_factor=None, in_vertical_raster=None, vertical_factor=None, maximum_distance=None, out_backlink_raster=None):
    """PathDistance_sa(in_source_data, {in_cost_raster}, {in_surface_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor}, {maximum_distance}, {out_backlink_raster})
       
       Calculates, for each cell, the least accumulative cost distance to the nearest source, while accounting for surface distance and horizontal and vertical cost factors.
       
       INPUTS:
         in_source_data (Composite Geodataset, Required): Input raster or feature source data
         in_cost_raster (Composite Geodataset, Optional): Input cost raster
         in_surface_raster (Composite Geodataset, Optional): Input surface raster
         in_horizontal_raster (Composite Geodataset, Optional): Input horizontal raster
         horizontal_factor (Horizontal factor, Optional): Horizontal factor
         in_vertical_raster (Composite Geodataset, Optional): Input vertical raster
         vertical_factor (Vertical factor, Optional): Vertical factor
         maximum_distance (Double, Optional): Maximum distance
       OUTPUT:
         out_backlink_raster (Raster Dataset, Optional): Output backlink raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PathDistance_sa(*gp_fixargs((in_source_data, in_cost_raster, in_surface_raster, in_horizontal_raster, horizontal_factor, in_vertical_raster, vertical_factor, maximum_distance, out_backlink_raster), True)))

@gptooldoc('Pick_sa', None)
def Pick(in_position_raster=None, in_rasters_or_constants=None):
    """Pick_sa(in_position_raster, [in_raster_or_constant,...])
       
       Assigns output values using one of a list of rasters determined by the value of an input raster.
       
       INPUTS:
         in_position_raster (Composite Geodataset, Required): Input position raster
         in_rasters_or_constants (Composite Geodataset, Required): Input rasters or constant values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Pick_sa(*gp_fixargs((in_position_raster, in_rasters_or_constants), True)))

@gptooldoc('Plus_sa', None)
def Plus(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Plus_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Adds the values of two rasters on a cell-by-cell basis within the Analysis window.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Plus_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('PointDensity_sa', None)
def PointDensity(in_point_features=None, population_field=None, cell_size=None, neighborhood=None, area_unit_scale_factor=None):
    """PointDensity_sa(in_point_features, population_field, {cell_size}, {neighborhood}, {SQUARE_MAP_UNITS | SQUARE_MILES | SQUARE_KILOMETERS | ACRES | HECTARES | SQUARE_YARDS | SQUARE_FEET | SQUARE_INCHES | SQUARE_METERS | SQUARE_CENTIMETERS | SQUARE_MILLIMETERS})
       
       Calculates a magnitude per unit area from point features that fall within a neighborhood around each cell.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         population_field (Field, Required): Population Field
         cell_size (Analysis cell size, Optional): Output cell size
         neighborhood (Neighborhood, Optional): Neighborhood
         area_unit_scale_factor (String, Optional): Area units"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PointDensity_sa(*gp_fixargs((in_point_features, population_field, cell_size, neighborhood, area_unit_scale_factor), True)))

@gptooldoc('PointStatistics_sa', None)
def PointStatistics(in_point_features=None, field=None, cell_size=None, neighborhood=None, statistics_type=None):
    """PointStatistics_sa(in_point_features, field, {cell_size}, {neighborhood}, {MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY})
       
       Calculates a statistic on points over a specified neighborhood outputting a raster.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         field (Field, Required): Field
         cell_size (Analysis cell size, Optional): Cell size
         neighborhood (Neighborhood, Optional): Neighborhood
         statistics_type (String, Optional): Overlay statistic"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PointStatistics_sa(*gp_fixargs((in_point_features, field, cell_size, neighborhood, statistics_type), True)))

@gptooldoc('PointsSolarRadiation_sa', None)
def PointsSolarRadiation(in_surface_raster=None, in_points_feature_or_table=None, out_global_radiation_features=None, height_offset=None, latitude=None, sky_size=None, time_configuration=None, day_interval=None, hour_interval=None, each_interval=None, z_factor=None, slope_aspect_input_type=None, calculation_directions=None, zenith_divisions=None, azimuth_divisions=None, diffuse_model_type=None, diffuse_proportion=None, transmittivity=None, out_direct_radiation_features=None, out_diffuse_radiation_features=None, out_direct_duration_features=None):
    """PointsSolarRadiation_sa(in_surface_raster, in_points_feature_or_table, out_global_radiation_features, {height_offset}, {latitude}, {sky_size}, {time_configuration}, {day_interval}, {hour_interval}, {NOINTERVAL | INTERVAL}, {z_factor}, {FROM_DEM | FLAT_SURFACE | FROM_POINTS_TABLE }, {calculation_directions}, {zenith_divisions}, {azimuth_divisions}, {UNIFORM_SKY | STANDARD_OVERCAST_SKY}, {diffuse_proportion}, {transmittivity}, {out_direct_radiation_features}, {out_diffuse_radiation_features}, {out_direct_duration_features})
       
       Derives incoming solar radiation for specific locations in a point feature class or location table.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         in_points_feature_or_table (Table View, Required): Input points feature or table
         height_offset (Double, Optional): Height offset
         latitude (Double, Optional): Latitude
         sky_size (Long, Optional): Sky size / Resolution
         time_configuration (Time configuration, Optional): Time configuration
         day_interval (Long, Optional): Day interval
         hour_interval (Double, Optional): Hour interval 
         each_interval (Boolean, Optional): Create outputs for each interval
         z_factor (Double, Optional): Z factor
         slope_aspect_input_type (String, Optional): Slope and aspect input type
         calculation_directions (Long, Optional): Calculation directions
         zenith_divisions (Long, Optional): Zenith divisions
         azimuth_divisions (Long, Optional): Azimuth divisions
         diffuse_model_type (String, Optional): Diffuse model type
         diffuse_proportion (Double, Optional): Diffuse proportion
         transmittivity (Double, Optional): Transmittivity
       OUTPUTS:
         out_global_radiation_features (Feature Class, Required): Output global radiation features
         out_direct_radiation_features (Feature Class, Optional): Output direct radiation features
         out_diffuse_radiation_features (Feature Class, Optional): Output diffuse radiation features
         out_direct_duration_features (Feature Class, Optional): Output direct duration features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PointsSolarRadiation_sa(*gp_fixargs((in_surface_raster, in_points_feature_or_table, out_global_radiation_features, height_offset, latitude, sky_size, time_configuration, day_interval, hour_interval, each_interval, z_factor, slope_aspect_input_type, calculation_directions, zenith_divisions, azimuth_divisions, diffuse_model_type, diffuse_proportion, transmittivity, out_direct_radiation_features, out_diffuse_radiation_features, out_direct_duration_features), True)))

@gptooldoc('Popularity_sa', None)
def Popularity(in_popularity_raster_or_constant=None, in_rasters=None):
    """Popularity_sa(in_popularity_raster_or_constant, [in_raster,...])
       
       Determines the value in an argument list that is at a certain level of popularity on a cell-by-cell basis within the Analysis window. The particular level of popularity (the number of occurrences of each value) is specified by the first argument.
       
       INPUTS:
         in_popularity_raster_or_constant (Composite Geodataset, Required): Input popularity raster or constant value
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Popularity_sa(*gp_fixargs((in_popularity_raster_or_constant, in_rasters), True)))

@gptooldoc('PorousPuff_sa', None)
def PorousPuff(in_track_file=None, in_porosity_raster=None, in_thickness_raster=None, mass=None, dispersion_time=None, longitudinal_dispersivity=None, dispersivity_ratio=None, retardation_factor=None, decay_coefficient=None):
    """PorousPuff_sa(in_track_file, in_porosity_raster, in_thickness_raster, mass, {dispersion_time}, {longitudinal_dispersivity}, {dispersivity_ratio}, {retardation_factor}, {decay_coefficient})
       
       Calculates the time-dependent, two-dimensional concentration distribution in mass per volume of a solute introduced instantaneously and at a discrete point into a vertically mixed aquifer.
       
       INPUTS:
         in_track_file (File, Required): Input particle track file
         in_porosity_raster (Composite Geodataset, Required): Input effective formation porosity raster
         in_thickness_raster (Composite Geodataset, Required): Input saturated thickness raster
         mass (Double, Required): Mass
         dispersion_time (Double, Optional): Dispersion time
         longitudinal_dispersivity (Double, Optional): Longitudinal dispersivity
         dispersivity_ratio (Double, Optional): Dispersivity ratio
         retardation_factor (Double, Optional): Retardation factor
         decay_coefficient (Double, Optional): Decay coefficient"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PorousPuff_sa(*gp_fixargs((in_track_file, in_porosity_raster, in_thickness_raster, mass, dispersion_time, longitudinal_dispersivity, dispersivity_ratio, retardation_factor, decay_coefficient), True)))

@gptooldoc('Power_sa', None)
def Power(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Power_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Raises the cells in a raster to the power of the values found in another raster.
       
       INPUTS:
         in_raster_or_constant1 (, Required): Input raster or constant value 1
         in_raster_or_constant2 (, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Power_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('PrincipalComponents_sa', None)
def PrincipalComponents(in_raster_bands=None, number_components=None, out_data_file=None):
    """PrincipalComponents_sa([in_raster_band,...], {number_components}, {out_data_file})
       
       Performs principal components analysis on a set of raster bands.
       
       INPUTS:
         in_raster_bands (Composite Geodataset, Required): Input raster bands
         number_components (Long, Optional): Number of Principal components
       OUTPUT:
         out_data_file (File, Optional): Output data file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.PrincipalComponents_sa(*gp_fixargs((in_raster_bands, number_components, out_data_file), True)))

@gptooldoc('Rank_sa', None)
def Rank(in_rank_raster_or_constant=None, in_rasters=None):
    """Rank_sa(in_rank_raster_or_constant, [in_raster,...])
       
       Returns the value of a set of rasters based on a rank level specified by another raster.
       
       INPUTS:
         in_rank_raster_or_constant (Composite Geodataset, Required): Input rank raster or constant value
         in_rasters (Composite Geodataset, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Rank_sa(*gp_fixargs((in_rank_raster_or_constant, in_rasters), True)))

@gptooldoc('ReclassByASCIIFile_sa', None)
def ReclassByASCIIFile(in_raster=None, in_remap_file=None, missing_values=None):
    """ReclassByASCIIFile_sa(in_raster, in_remap_file, {DATA | NODATA})
       
       Reclassifies or changes the values of the input cells of a raster using an ASCII remap file.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_remap_file (File, Required): Input ASCII remap file
         missing_values (Boolean, Optional): Change missing values to NoData"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ReclassByASCIIFile_sa(*gp_fixargs((in_raster, in_remap_file, missing_values), True)))

@gptooldoc('ReclassByTable_sa', None)
def ReclassByTable(in_raster=None, in_remap_table=None, from_value_field=None, to_value_field=None, output_value_field=None, missing_values=None):
    """ReclassByTable_sa(in_raster, in_remap_table, from_value_field, to_value_field, output_value_field, {DATA | NODATA})
       
       Reclassifies or changes the values of the input cells of a raster using a remap table.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_remap_table (Table View, Required): Input remap table
         from_value_field (Field, Required): From value field
         to_value_field (Field, Required): To value field
         output_value_field (Field, Required): Output value field
         missing_values (Boolean, Optional): Change missing values to NoData"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ReclassByTable_sa(*gp_fixargs((in_raster, in_remap_table, from_value_field, to_value_field, output_value_field, missing_values), True)))

@gptooldoc('Reclassify_sa', None)
def Reclassify(in_raster=None, reclass_field=None, remap=None, missing_values=None):
    """Reclassify_sa(in_raster, reclass_field, remap, {DATA | NODATA})
       
       Reclassifies (or changes) the values in a raster.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         reclass_field (Field, Required): Reclass field
         remap (Remap, Required): Reclassification
         missing_values (Boolean, Optional): Change missing values to NoData"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Reclassify_sa(*gp_fixargs((in_raster, reclass_field, remap, missing_values), True)))

@gptooldoc('RegionGroup_sa', None)
def RegionGroup(in_raster=None, number_neighbors=None, zone_connectivity=None, add_link=None, excluded_value=None):
    """RegionGroup_sa(in_raster, {FOUR | EIGHT}, {WITHIN | CROSS}, {ADD_LINK | NO_LINK}, {excluded_value})
       
       For each cell in the output, Regiongroup records the identity of the connected region to which that cell belongs.  A unique number is assigned to each region.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         number_neighbors (String, Optional): Number of neighbors to use
         zone_connectivity (String, Optional): Zone grouping method
         add_link (Boolean, Optional): Add link field to output
         excluded_value (Long, Optional): Excluded value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.RegionGroup_sa(*gp_fixargs((in_raster, number_neighbors, zone_connectivity, add_link, excluded_value), True)))

@gptooldoc('RoundDown_sa', None)
def RoundDown(in_raster_or_constant=None):
    """RoundDown_sa(in_raster_or_constant)
       
       Returns the next lower whole number for each cell in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.RoundDown_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('RoundUp_sa', None)
def RoundUp(in_raster_or_constant=None):
    """RoundUp_sa(in_raster_or_constant)
       
       Returns the next higher whole number for each cell in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.RoundUp_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Sample_sa', None)
def Sample(in_raster=None, in_location_data=None, out_table=None, resampling_type=None):
    """Sample_sa([raster,...], in_location_data, out_table, {NEAREST | BILINEAR | CUBIC})
       
       Creates a table that shows the values of cells from a raster, or set of rasters, for defined locations. The locations are defined by raster cells or by a set of points.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input rasters
         in_location_data (Composite Geodataset, Required): Input location raster or point features
         resampling_type (String, Optional): Resampling technique
       OUTPUT:
         out_table (Table, Required): Output table"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Sample_sa(*gp_fixargs((in_raster, in_location_data, out_table, resampling_type), True)))

@gptooldoc('SetNull_sa', None)
def SetNull(in_conditional_raster=None, in_false_raster_or_constant=None, where_clause=None):
    """SetNull_sa(in_conditional_raster, in_false_raster_or_constant, {where_clause})
       
       Returns NoData if a conditional evaluation is true and returns the value specified by another raster if it is false, on a cell-by-cell basis.
       
       INPUTS:
         in_conditional_raster (Composite Geodataset, Required): Input conditional raster
         in_false_raster_or_constant (Composite Geodataset, Required): Input false raster or constant value
         where_clause (SQL Expression, Optional): Where clause"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SetNull_sa(*gp_fixargs((in_conditional_raster, in_false_raster_or_constant, where_clause), True)))

@gptooldoc('Shrink_sa', None)
def Shrink(in_raster=None, number_cells=None, zone_values=None):
    """Shrink_sa(in_raster, number_cells, [zone_value,...])
       
       Shrinks the selected zones by a specified number of cells.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         number_cells (Long, Required): Number of cells
         zone_values (Long, Required): Zone values"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Shrink_sa(*gp_fixargs((in_raster, number_cells, zone_values), True)))

@gptooldoc('SinH_sa', None)
def SinH(in_raster_or_constant=None):
    """SinH_sa(in_raster_or_constant)
       
       Calculates the hyperbolic sine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SinH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Sin_sa', None)
def Sin(in_raster_or_constant=None):
    """Sin_sa(in_raster_or_constant)
       
       Calculates the sine of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Sin_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptoolnotsupported
@gptooldoc('SingleOutputMapAlgebra_sa', None)
def SingleOutputMapAlgebra(expression_string=None, out_raster=None, in_data=None):
    """SingleOutputMapAlgebra_sa(expression_string, out_raster, {in_data})
       
       Runs a single expression built with the Map Algebra language.
       
       INPUTS:
         expression_string (MapAlgebra Expression, Required): Map Algebra expression
         in_data (Composite Geodataset, Optional): Input raster or feature data
       OUTPUT:
         out_raster (Raster Dataset, Required): Output raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SingleOutputMapAlgebra_sa(*gp_fixargs((expression_string, out_raster, in_data), True)))

@gptooldoc('Sink_sa', None)
def Sink(in_flow_direction_raster=None):
    """Sink_sa(in_flow_direction_raster)
       
       Creates a raster identifying all sinks or areas of internal drainage.
       
       INPUT:
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Sink_sa(*gp_fixargs((in_flow_direction_raster, ), True)))

@gptooldoc('Slice_sa', None)
def Slice(in_raster=None, number_zones=None, slice_type=None, base_output_zone=None):
    """Slice_sa(in_raster, number_zones, {EQUAL_INTERVAL | EQUAL_AREA | NATURAL_BREAKS}, {base_output_zone})
       
       Slices a range of values of the input cells of a raster by zones of equal interval, equal area, or by natural breaks.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         number_zones (Long, Required): Number of output zones
         slice_type (String, Optional): Slice method
         base_output_zone (Long, Optional): Base zone for output"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Slice_sa(*gp_fixargs((in_raster, number_zones, slice_type, base_output_zone), True)))

@gptooldoc('Slope_sa', None)
def Slope(in_raster=None, output_measurement=None, z_factor=None):
    """Slope_sa(in_raster, {DEGREE | PERCENT_RISE}, {z_factor})
       
       Identifies the rate of maximum change in z-value from each cell.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         output_measurement (String, Optional): Output measurement
         z_factor (Double, Optional): Z factor"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Slope_sa(*gp_fixargs((in_raster, output_measurement, z_factor), True)))

@gptooldoc('SnapPourPoint_sa', None)
def SnapPourPoint(in_pour_point_data=None, in_accumulation_raster=None, snap_distance=None, pour_point_field=None):
    """SnapPourPoint_sa(in_pour_point_data, in_accumulation_raster, snap_distance, {pour_point_field})
       
       Snaps pour points to the cell of highest flow accumulation within a specified distance.
       
       INPUTS:
         in_pour_point_data (Composite Geodataset, Required): Input raster or feature pour point data
         in_accumulation_raster (Composite Geodataset, Required): Input accumulation raster
         snap_distance (Double, Required): Snap distance
         pour_point_field (Field, Optional): Pour point field"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SnapPourPoint_sa(*gp_fixargs((in_pour_point_data, in_accumulation_raster, snap_distance, pour_point_field), True)))

@gptooldoc('SolarRadiationGraphics_sa', None)
def SolarRadiationGraphics(in_surface_raster=None, in_points_feature_or_table=None, sky_size=None, height_offset=None, calculation_directions=None, latitude=None, time_configuration=None, day_interval=None, hour_interval=None, out_sunmap_raster=None, zenith_divisions=None, azimuth_divisions=None, out_skymap_raster=None):
    """SolarRadiationGraphics_sa(in_surface_raster, {in_points_feature_or_table}, {sky_size}, {height_offset}, {calculation_directions}, {latitude}, {time_configuration}, {day_interval}, {hour_interval}, {out_sunmap_raster}, {zenith_divisions}, {azimuth_divisions}, {out_skymap_raster})
       
       Derives raster representations of a hemispherical viewshed, sunmap, and skymap, which are used in the calculation of direct, diffuse, and global solar radiation.
       
       INPUTS:
         in_surface_raster (Composite Geodataset, Required): Input surface raster
         in_points_feature_or_table (Table View, Optional): Input points feature or table
         sky_size (Long, Optional): Sky size / Resolution
         height_offset (Double, Optional): Height offset
         calculation_directions (Long, Optional): Calculation directions
         latitude (Double, Optional): Latitude
         time_configuration (Time configuration, Optional): Time configuration
         day_interval (Long, Optional): Day interval
         hour_interval (Double, Optional): Hour interval 
         zenith_divisions (Long, Optional): Zenith divisions
         azimuth_divisions (Long, Optional): Azimuth divisions
       OUTPUTS:
         out_sunmap_raster (Raster Dataset, Optional): Output sunmap raster
         out_skymap_raster (Raster Dataset, Optional): Output skymap raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SolarRadiationGraphics_sa(*gp_fixargs((in_surface_raster, in_points_feature_or_table, sky_size, height_offset, calculation_directions, latitude, time_configuration, day_interval, hour_interval, out_sunmap_raster, zenith_divisions, azimuth_divisions, out_skymap_raster), True)))

@gptooldoc('Spline_sa', None)
def Spline(in_point_features=None, z_field=None, cell_size=None, spline_type=None, weight=None, number_points=None):
    """Spline_sa(in_point_features, z_field, {cell_size}, {REGULARIZED | TENSION}, {weight}, {number_points})
       
       Interpolates a surface from points using a minimum curvature spline technique.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         z_field (Field, Required): Z value field
         cell_size (Analysis cell size, Optional): Output cell size
         spline_type (String, Optional): Spline type
         weight (Double, Optional): Weight
         number_points (Long, Optional): Number of points"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Spline_sa(*gp_fixargs((in_point_features, z_field, cell_size, spline_type, weight, number_points), True)))

@gptooldoc('SquareRoot_sa', None)
def SquareRoot(in_raster_or_constant=None):
    """SquareRoot_sa(in_raster_or_constant)
       
       Calculates the square root of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.SquareRoot_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Square_sa', None)
def Square(in_raster_or_constant=None):
    """Square_sa(in_raster_or_constant)
       
       Calculates the square of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Square_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('StreamLink_sa', None)
def StreamLink(in_stream_raster=None, in_flow_direction_raster=None):
    """StreamLink_sa(in_stream_raster, in_flow_direction_raster)
       
       Assigns unique values to sections of a raster linear network between intersections.
       
       INPUTS:
         in_stream_raster (Composite Geodataset, Required): Input stream raster
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.StreamLink_sa(*gp_fixargs((in_stream_raster, in_flow_direction_raster), True)))

@gptooldoc('StreamOrder_sa', None)
def StreamOrder(in_stream_raster=None, in_flow_direction_raster=None, order_method=None):
    """StreamOrder_sa(in_stream_raster, in_flow_direction_raster, {STRAHLER | SHREVE})
       
       Assigns a numeric order to segments of a raster representing branches of a linear network.
       
       INPUTS:
         in_stream_raster (Composite Geodataset, Required): Input stream raster
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster
         order_method (String, Optional): Method of stream ordering"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.StreamOrder_sa(*gp_fixargs((in_stream_raster, in_flow_direction_raster, order_method), True)))

@gptooldoc('StreamToFeature_sa', None)
def StreamToFeature(in_stream_raster=None, in_flow_direction_raster=None, out_polyline_features=None, simplify=None):
    """StreamToFeature_sa(in_stream_raster, in_flow_direction_raster, out_polyline_features, {SIMPLIFY | NO_SIMPLIFY})
       
       Converts a raster representing a linear network to features representing the linear network.
       
       INPUTS:
         in_stream_raster (Composite Geodataset, Required): Input stream raster
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster
         simplify (Boolean, Optional): Simplify polylines
       OUTPUT:
         out_polyline_features (Feature Class, Required): Output polyline features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.StreamToFeature_sa(*gp_fixargs((in_stream_raster, in_flow_direction_raster, out_polyline_features, simplify), True)))

@gptooldoc('TabulateArea_sa', None)
def TabulateArea(in_zone_data=None, zone_field=None, in_class_data=None, class_field=None, out_table=None, processing_cell_size=None):
    """TabulateArea_sa(in_zone_data, zone_field, in_class_data, class_field, out_table, {processing_cell_size})
       
       Calculates cross-tabulated areas between two datasets.
       
       INPUTS:
         in_zone_data (Composite Geodataset, Required): Input raster or feature zone data
         zone_field (Field, Required): Zone field
         in_class_data (Composite Geodataset, Required): Input raster or feature class data
         class_field (Field, Required): Class field
         processing_cell_size (Analysis cell size, Optional): Processing cell size
       OUTPUT:
         out_table (Table, Required): Output table"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.TabulateArea_sa(*gp_fixargs((in_zone_data, zone_field, in_class_data, class_field, out_table, processing_cell_size), True)))

@gptooldoc('TanH_sa', None)
def TanH(in_raster_or_constant=None):
    """TanH_sa(in_raster_or_constant)
       
       Calculates the hyperbolic tangent of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.TanH_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Tan_sa', None)
def Tan(in_raster_or_constant=None):
    """Tan_sa(in_raster_or_constant)
       
       Calculates the tangent of cells in a raster.
       
       INPUT:
         in_raster_or_constant (Composite Geodataset, Required): Input raster or constant value"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Tan_sa(*gp_fixargs((in_raster_or_constant, ), True)))

@gptooldoc('Test_sa', None)
def Test(in_raster=None, where_clause=None):
    """Test_sa(in_raster, where_clause)
       
       A logical expression used to perform a Boolean evaluation of the input raster.  When the expression evaluates to true, the output cell value is 1.  If the expression is false, the output cell value is 0.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         where_clause (SQL Expression, Required): Where clause"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Test_sa(*gp_fixargs((in_raster, where_clause), True)))

@gptooldoc('Thin_sa', None)
def Thin(in_raster=None, background_value=None, filter=None, corners=None, maximum_thickness=None):
    """Thin_sa(in_raster, {ZERO | NODATA}, {NO_FILTER | FILTER}, {ROUND | SHARP}, {maximum_thickness})
       
       Thins rasterized linear features by reducing the number of cells representing the width of the features.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         background_value (String, Optional): Background value
         filter (Boolean, Optional): Filter input first
         corners (String, Optional): Shape for corners
         maximum_thickness (Double, Optional): Maximum thickness of input linear features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Thin_sa(*gp_fixargs((in_raster, background_value, filter, corners, maximum_thickness), True)))

@gptooldoc('Times_sa', None)
def Times(in_raster_or_constant1=None, in_raster_or_constant2=None):
    """Times_sa(in_raster_or_constant1, in_raster_or_constant2)
       
       Multiplies the values of two rasters on a cell-by-cell basis.
       
       INPUTS:
         in_raster_or_constant1 (Composite Geodataset, Required): Input raster or constant value 1
         in_raster_or_constant2 (Composite Geodataset, Required): Input raster or constant value 2"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Times_sa(*gp_fixargs((in_raster_or_constant1, in_raster_or_constant2), True)))

@gptooldoc('TopoToRasterByFile_sa', None)
def TopoToRasterByFile(in_parameter_file=None, out_stream_features=None, out_sink_features=None):
    """TopoToRasterByFile_sa(in_parameter_file, {out_stream_features}, {out_sink_features})
       
       Interpolates a hydrologically correct surface from point, line, and polygon data using parameters specified in a file.
       Learn more about how Topo to Raster works
       
       INPUT:
         in_parameter_file (File, Required): Input parameter file
       OUTPUTS:
         out_stream_features (Feature Class, Optional): Output stream polyline features
         out_sink_features (Feature Class, Optional): Output remaining sink point features"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.TopoToRasterByFile_sa(*gp_fixargs((in_parameter_file, out_stream_features, out_sink_features), True)))

@gptooldoc('TopoToRaster_sa', None)
def TopoToRaster(in_topo_features=None, cell_size=None, extent=None, margin=None, minimum_z_value=None, maximum_z_value=None, enforce=None, data_type=None, maximum_iterations=None, roughness_penalty=None, discrete_error_factor=None, vertical_standard_error=None, tolerance_1=None, tolerance_2=None, out_stream_features=None, out_sink_features=None, out_diagnostic_file=None, out_parameter_file=None):
    """TopoToRaster_sa(topo_input , {cell_size}, {extent}, {margin}, {minimum_z_value}, {maximum_z_value}, {ENFORCE | NO_ENFORCE | ENFORCE_WITH_SINK}, {CONTOUR | SPOT}, {maximum_iterations}, {roughness_penalty}, {discrete_error_factor}, {vertical_standard_error}, {tolerance_1}, {tolerance_2}, {out_stream_features}, {out_sink_features}, {out_diagnostic_file}, {out_parameter_file})
       
       Interpolates a hydrologically correct surface from point, line, and polygon data.
       Learn more about how Topo to Raster works
       
       INPUTS:
         in_topo_features ((Feature Layer Field String; Feature Layer Field String;...), Required): Input feature data
         cell_size (Analysis cell size, Optional): Output cell size
         extent (Envelope, Optional): Output extent
         margin (Long, Optional): Margin in cells
         minimum_z_value (Double, Optional): Smallest z value to be used in interpolation
         maximum_z_value (Double, Optional): Largest z value to be used in interpolation
         enforce (String, Optional): Drainage enforcement
         data_type (String, Optional): Primary type of input data
         maximum_iterations (Long, Optional): Maximum number of iterations
         roughness_penalty (Double, Optional): Roughness penalty
         discrete_error_factor (Double, Optional): Discrete error factor
         vertical_standard_error (Double, Optional): Vertical standard error
         tolerance_1 (Double, Optional): Tolerance 1
         tolerance_2 (Double, Optional): Tolerance 2
       OUTPUTS:
         out_stream_features (Feature Class, Optional): Output stream features
         out_sink_features (Feature Class, Optional): Output sinks features
         out_diagnostic_file (File, Optional): Output diagnostic file
         out_parameter_file (File, Optional): Output parameter file"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.TopoToRaster_sa(*gp_fixargs((in_topo_features, cell_size, extent, margin, minimum_z_value, maximum_z_value, enforce, data_type, maximum_iterations, roughness_penalty, discrete_error_factor, vertical_standard_error, tolerance_1, tolerance_2, out_stream_features, out_sink_features, out_diagnostic_file, out_parameter_file), True)))

@gptooldoc('Trend_sa', None)
def Trend(in_point_features=None, z_field=None, cell_size=None, order=None, regression_type=None, out_rms_file=None):
    """Trend_sa(in_point_features, z_field, {cell_size}, {order}, {LINEAR | LOGISTIC}, {out_rms_file})
       
       Interpolates a surface from points using a trend technique.
       
       INPUTS:
         in_point_features (Composite Geodataset, Required): Input point features
         z_field (Field, Required): Z value field
         cell_size (Analysis cell size, Optional): Output cell size
         order (Long, Optional): Polynomial order
         regression_type (String, Optional): Type of regression
       OUTPUT:
         out_rms_file (File, Optional): The name of the output containing RMS error and Chi-Square values."""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Trend_sa(*gp_fixargs((in_point_features, z_field, cell_size, order, regression_type, out_rms_file), True)))

@gptooldoc('Viewshed_sa', None)
def Viewshed(in_raster=None, in_observer_features=None, z_factor=None, curvature_correction=None, refractivity_coefficient=None):
    """Viewshed_sa(in_raster, in_observer_features, {z_factor}, {FLAT_EARTH | CURVED_EARTH}, {refractivity_coefficient})
       
       Determines the raster surface locations visible to a set of observer features.
       
       INPUTS:
         in_raster (Composite Geodataset, Required): Input raster
         in_observer_features (Composite Geodataset, Required): Input point or polyline observer features
         z_factor (Double, Optional): Z factor
         curvature_correction (Boolean, Optional): Use earth curvature corrections
         refractivity_coefficient (Double, Optional): Refractivity coefficient"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Viewshed_sa(*gp_fixargs((in_raster, in_observer_features, z_factor, curvature_correction, refractivity_coefficient), True)))

@gptooldoc('Watershed_sa', None)
def Watershed(in_flow_direction_raster=None, in_pour_point_data=None, pour_point_field=None):
    """Watershed_sa(in_flow_direction_raster, in_pour_point_data, {pour_point_field})
       
       Determines the contributing area above a set of cells in a raster.
       
       INPUTS:
         in_flow_direction_raster (Composite Geodataset, Required): Input flow direction raster
         in_pour_point_data (Composite Geodataset, Required): Input raster or feature pour point data
         pour_point_field (Field, Optional): Pour point field"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.Watershed_sa(*gp_fixargs((in_flow_direction_raster, in_pour_point_data, pour_point_field), True)))

@gptooldoc('WeightedOverlay_sa', None)
def WeightedOverlay(weighted_overlay_table=None):
    """WeightedOverlay_sa(weighted_overlay_table)
       
       Overlays several rasters using a common measurement scale and weights each according to its importance.
       
       INPUT:
         weighted_overlay_table (Weighted Overlay Table, Required): Weighted overlay table"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.WeightedOverlay_sa(*gp_fixargs((weighted_overlay_table, ), True)))

@gptooldoc('WeightedSum_sa', None)
def WeightedSum(weighted_sum_table=None):
    """WeightedSum_sa(weighted_sum_table)
       
       Overlays several rasters multiplying each by their given weight and summing them together.
       
       INPUT:
         weighted_sum_table (Weighted Sum Table, Required): Input rasters"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.WeightedSum_sa(*gp_fixargs((weighted_sum_table, ), True)))

@gptooldoc('ZonalFill_sa', None)
def ZonalFill(in_zone_raster=None, in_weight_raster=None):
    """ZonalFill_sa(in_zone_raster, in_weight_raster)
       
       Fills zones using the minimum cell value from a weight raster along the zone boundary.
       
       INPUTS:
         in_zone_raster (Composite Geodataset, Required): Input zone raster
         in_weight_raster (Composite Geodataset, Required): Input weight raster"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ZonalFill_sa(*gp_fixargs((in_zone_raster, in_weight_raster), True)))

@gptooldoc('ZonalGeometryAsTable_sa', None)
def ZonalGeometryAsTable(in_zone_data=None, zone_field=None, out_table=None, processing_cell_size=None):
    """ZonalGeometryAsTable_sa(in_zone_data, zone_field, out_table, {processing_cell_size})
       
       Calculates for each zone in a dataset the geometry measures for example, area, perimeter, thickness, and the characteristics of ellipse and reports the results as a table.
       
       INPUTS:
         in_zone_data (Composite Geodataset, Required): Input raster or feature zone data
         zone_field (Field, Required): Zone field
         processing_cell_size (Analysis cell size, Optional): Processing cell size
       OUTPUT:
         out_table (Table, Required): Output table"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ZonalGeometryAsTable_sa(*gp_fixargs((in_zone_data, zone_field, out_table, processing_cell_size), True)))

@gptooldoc('ZonalGeometry_sa', None)
def ZonalGeometry(in_zone_data=None, zone_field=None, geometry_type=None, cell_size=None):
    """ZonalGeometry_sa(in_zone_data, zone_field, {AREA | PERIMETER | THICKNESS | CENTROID}, {cell_size})
       
       Calculates for each zone in a dataset the specified geometry measure (area, perimeter, thickness, or the characteristics of ellipse).
       
       INPUTS:
         in_zone_data (Composite Geodataset, Required): Input raster or feature zone data
         zone_field (Field, Required): Zone field
         geometry_type (String, Optional): Geometry type
         cell_size (Analysis cell size, Optional): Output cell size"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ZonalGeometry_sa(*gp_fixargs((in_zone_data, zone_field, geometry_type, cell_size), True)))

@gptooldoc('ZonalStatisticsAsTable_sa', None)
def ZonalStatisticsAsTable(in_zone_data=None, zone_field=None, in_value_raster=None, out_table=None, ignore_nodata=None):
    """ZonalStatisticsAsTable_sa(in_zone_data, zone_field, in_value_raster, out_table, {DATA | NODATA})
       
       Summarizes the values of a raster within the zones of another dataset and reports the results to a table.
       
       INPUTS:
         in_zone_data (Composite Geodataset, Required): Input raster or feature zone data
         zone_field (Field, Required): Zone field
         in_value_raster (Composite Geodataset, Required): Input value raster
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations
       OUTPUT:
         out_table (Table, Required): Output table"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ZonalStatisticsAsTable_sa(*gp_fixargs((in_zone_data, zone_field, in_value_raster, out_table, ignore_nodata), True)))

@gptooldoc('ZonalStatistics_sa', None)
def ZonalStatistics(in_zone_data=None, zone_field=None, in_value_raster=None, statistics_type=None, ignore_nodata=None):
    """ZonalStatistics_sa(in_zone_data, zone_field, in_value_raster, {MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY}, {DATA | NODATA})
       
       Calculates statistics on values of a raster within the zones of another dataset.
       
       INPUTS:
         in_zone_data (Composite Geodataset, Required): Input raster or feature zone data
         zone_field (Field, Required): Zone field
         in_value_raster (Composite Geodataset, Required): Input value raster
         statistics_type (String, Optional): Overlay statistic
         ignore_nodata (Boolean, Optional): Ignore NoData in calculations"""
    with gp:
        return convertArcObjectToPythonObject(gp._gp.ZonalStatistics_sa(*gp_fixargs((in_zone_data, zone_field, in_value_raster, statistics_type, ignore_nodata), True)))

